// dps_fkt.h - include file Slave-LIB and the user
(*****************************************************************************/
/*  Project:    ProTool/Pro   SoftNet DP                                     */
/*  Component:  interface include file for the user of Slave-LIB             */
/*  Modul:      dps_fkt.h                                                    */
/*  Version:    V0.1                                                         */
/*  Autor:      Peter Gunkel A&D PT1 D1                                      */
/*  Date:       15.09.1998                                                   */
/*-------------------------------------------------------------------------- */

/*----------------------------------------------------------------------------*/
/*  Beschreibung:                                                             */
/*  in this file are the declarations of the exported Slave-LIB functions     */
/*                                                                            */
/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/
/*  History of Changes:                                                       */
/*  ===================                                                       */
/*                                                                            */
/*  Date    Person      Comment                                               */
/*  --------!-----!--------------------------------------------------------   */
/*                                                                            */
/*                                                                            */
/******************************************************************************)

{
ported to OPASCAL (on Delphi 5) by -=Assarbad=- 09.06.2001

includes dynamic or static binding
texts to according error codes

version for this converted header: v.1.02
}
unit dpslib;

{$DEFINE dynamicbinding}//with preceeding "$" = dynamic else static binding of DLL
//CDECL seems to be the one for me ;)
{DEFINE stdcallconv}//else CDECL

{$DEFINE packedrecs}

interface
uses windows;
type
  DPR_DWORD = ULONG;
  DPR_Byte = Byte;
  DPR_STRING = char;
  DPR_WORD = Word;
  PDPR_Byte = PByte;
  PDPR_STRING = PChar;

// structure for DPS_open
  DPS_INIT_DATA = {$IFDEF packedrecs}packed{$ENDIF}record
    case Integer of
      0: (
        user_prm_data_len: DPR_WORD;
        user_prm_data: array[0..243] of DPR_BYTE;
        cfg_data_len: DPR_WORD;
        cfg_data: array[0..243] of DPR_BYTE;
        );
      1: (
        def_cfg_data_len: DPR_WORD;
        def_cfg_data: array[0..243] of DPR_BYTE;
        );
  end;

  DPS_MAX_DATA = {$IFDEF packedrecs}packed{$ENDIF}record
    max_input_data_len,
      max_output_data_len,
      max_user_diag_len,
      max_user_prm_data_len,
      max_cfg_data_len,
      max_user_ssa_data_len: DPR_BYTE;
  end;

//--------------------------------------------------------------------------------------
// Errorhandling:
//--------------------------------------------------------------------------------------
// The structure DP_ERROR is used for error-handling between the dpslib and the
// application.
// error_class:		see error classes and return values
// error_code:		see special error_code for the error_class
// error_decode:	not used
// error_code_1:	not used
// error_code_2:	not used
//--------------------------------------------------------------------------------------
  DP_ERROR = {$IFDEF packedrecs}packed{$ENDIF}record
    error_class: DPR_DWORD;
    error_code: DPR_DWORD;
    error_decode: DPR_BYTE;
    error_code_1: DPR_BYTE;
    error_code_2: DPR_BYTE;
  end;

{$IFDEF dynamicbinding}
  TDPS_open = function(logname: PDPR_STRING;
    var user_handle: DPR_DWORD;
    slave_mode: DPR_DWORD;
    station_addr: DPR_WORD;
    addr_change: DPR_WORD;
    pno_ident_nr: DPR_WORD;
    user_wd: DPR_WORD;
    var init_data: DPS_INIT_DATA;
    var max_data_len: DPS_MAX_DATA;
    baudrate: DPR_WORD;
    var error: DP_ERROR): DPR_DWORD; {$IFDEF stdcallconv}stdcall; {$ELSE}cdecl; {$ENDIF}

  TDPS_start_stop_close = function(user_handle: DPR_DWORD; var error: DP_ERROR): DPR_DWORD; {$IFDEF stdcallconv}stdcall; {$ELSE}cdecl; {$ENDIF}

  TDPS_set_get_input_output = function(user_handle: DPR_DWORD;
    data: PDPR_BYTE;
    len: DPR_WORD;
    var error: DP_ERROR): DPR_DWORD; {$IFDEF stdcallconv}stdcall; {$ELSE}cdecl; {$ENDIF}

var
  DPS_open: TDPS_open = nil;
  DPS_start: TDPS_start_stop_close = nil;
  DPS_stop: TDPS_start_stop_close = nil;
  DPS_close: TDPS_start_stop_close = nil;
  DPS_set_input: TDPS_set_get_input_output = nil;
  DPS_get_output: TDPS_set_get_input_output = nil;
{$ELSE}
function DPS_open(logname: PDPR_STRING;
  var user_handle: DPR_DWORD;
  slave_mode: DPR_DWORD;
  station_addr: DPR_WORD;
  addr_change: DPR_WORD;
  pno_ident_nr: DPR_WORD;
  user_wd: DPR_WORD;
  var init_data: DPS_INIT_DATA;
  var max_data_len: DPS_MAX_DATA;
  baudrate: DPR_WORD;
  var error: DP_ERROR): DPR_DWORD; {$IFDEF stdcallconv}stdcall; {$ELSE}cdecl; {$ENDIF}

function DPS_start(user_handle: DPR_DWORD; var error: DP_ERROR): DPR_DWORD; {$IFDEF stdcallconv}stdcall; {$ELSE}cdecl; {$ENDIF}
function DPS_stop(user_handle: DPR_DWORD; var error: DP_ERROR): DPR_DWORD; {$IFDEF stdcallconv}stdcall; {$ELSE}cdecl; {$ENDIF}
function DPS_close(user_handle: DPR_DWORD; var error: DP_ERROR): DPR_DWORD; {$IFDEF stdcallconv}stdcall; {$ELSE}cdecl; {$ENDIF}

function DPS_set_input(user_handle: DPR_DWORD;
  data: PDPR_BYTE;
  len: DPR_WORD;
  var error: DP_ERROR): DPR_DWORD; {$IFDEF stdcallconv}stdcall; {$ELSE}cdecl; {$ENDIF}

function DPS_get_output(user_handle: DPR_DWORD;
  data: PDPR_BYTE;
  len: DPR_WORD;
  var error: DP_ERROR): DPR_DWORD; {$IFDEF stdcallconv}stdcall; {$ELSE}cdecl; {$ENDIF}
{$ENDIF}

const
  libname = 'DPSLIB.DLL';

//slave mode
  DPS_SM_SIMPLE = $01;
  DPS_SM_V1_ENABLE = $02;
  DPS_SM_FREEZE_SUPP = $04;
  DPS_SM_SYNC_SUPP = $08;

//baudrate
  DPS_BD_9K6 = $00;
  DPS_BD_19K2 = $01;
  DPS_BD_93K75 = $02;
  DPS_BD_187K5 = $03;
  DPS_BD_500K = $04;
  DPS_BD_1M5 = $07;
  DPS_BD_3M = $08;
  DPS_BD_6M = $0A;
  DPS_BD_12M = $0B;
  DPS_BD_45K45 = $0C;
  DPS_BD_AUTO_DETECT = $0D;
  DPS_BD_INVALID = $FF;

// error classes and return values
  DP_OK = 0; // everything is OK
  DP_ERROR_EVENT_NET = 1; // something wrong with the communication
  DP_ERROR_REQ_PAR = 2; // wrong call or wrong parameters
  DP_ERROR_CI = 3; // not used
  DP_ERROR_RES = 4; // not enough system or layer2 ressources
  DP_ERROR_USR_ABORT = 5; // not used

// error code for DP_ERROR_EVENT_NET
  DPS_ERROR_EV_NO_DATA_EX = 1; // DP-Slave is not in Data-Exchange
  DPS_ERROR_EV_START_FAILED = 2; // Start-Commando failed
  DPS_ERROR_SIM9SYNC_FAILED = 3; // call to sim9sync failed, contact SIEMENS AG
  DPS_ERROR_EV_COMM_ERR = 4; // communication error

// error code for DP_ERROR_REQ_PAR
  DPS_ERROR_PAR_INTERNAL = 1; // internal Error: contact SIEMENS AG
  DPS_ERROR_PAR_SLAVE_MODE = 2; // this slave_mode is not allowed
  DPS_ERROR_PAR_ADDR_CHANGE = 3; // no addr_change allowed
  DPS_ERROR_PAR_USER_HANDLE = 4; // wrong user_handle
  DPS_ERROR_PAR_STATION_ADDR = 5; // station_addr > 126 not allowed
  DPS_ERROR_PAR_INPUT_DATA = 6; // no input data ptr
  DPS_ERROR_PAR_OUTPUT_DATA = 7; // no output data ptr
  DPS_ERROR_PAR_BAUDRATE = 8; // wrong baudrate
  DPS_ERROR_REQ_NOT_ALLOWED = 9; // this request is not allowed in this state
  DPS_ERROR_REQ_DPS_ACTIVE = 10; // this request is not allowed, there is another active request
  DPS_ERROR_PAR_OUTPUT_LEN = 11; // parameter len is wrong
  DPS_ERROR_PAR_INPUT_LEN = 12; // parameter len is wrong
  DPS_ERROR_PAR_IO_LEN = 13; // too much I/O configured; only 122 I/O allowed
  DPS_ERROR_PAR_CFG_DATA = 14; // wrong cfg_data: no input and no output

// error code for DP_ERROR_RES
  DPS_ERROR_RES_OPEN = 1; // no further SCP_OPEN possible
  DPS_ERROR_RES_ALLOC = 2; // System- or Layer2 - Alloc failed
  DPS_ERROR_RES_DEALLOC = 3; // System- or Layer2 - DeAlloc failed
  DPS_ERROR_RES_REG_BAUDRATE = 4; // write baudrate into registry failed
  DPS_ERROR_RES_REG_TS = 5; // write station address into registry failed
  DPS_ERROR_RES_REG_LOG_DEVICE = 6; // log. device or name not detected in registry
  DPS_ERROR_RES_REG_TSLOT = 7; // write tslot into registry failed

// error decode for DPS_ERROR_PAR_INTERNAL
  DPS_ERROR_INTERNAL_SCP_PARAM = 1; // internal error 1 (SCP)
  DPS_ERROR_INTERNAL_AMPRO2_LOAD = 2; // internal error 2 (Ampro2 load)
  DPS_ERROR_INTERNAL_AMPRO2_OPEN = 3; // internal error 3 (Ampro2 open)

// error decode for DPS_ERROR_RES_ALLOC
  DPS_ERROR_RES_ALLOC_SYS = 1; // System-Alloc failed
  DPS_ERROR_RES_ALLOC_AMPRO2 = 2; // Ampro2-Alloc failed

// error decode for DPS_ERROR_RES_DEALLOC
  DPS_ERROR_RES_DEALLOC_SYS = 1; // System-DeAlloc failed
  DPS_ERROR_RES_DEALLOC_AMPRO2 = 2; // Ampro2-DeAlloc failed

// error decode for DPS_ERROR_PAR_CFG_DATA
// here is the index of the wrong cfg_data - byte (Bit 4 or Bit 5 in cfg_data is not set)

//boundaries of error constants:
  DP_ERROR_CLASSMIN = DP_OK;
  DP_ERROR_CLASSMAX = DP_ERROR_USR_ABORT;
  DP_ERROR_CODEMIN = 1;
  DP_ERROR_CODEMAX = DPS_ERROR_PAR_CFG_DATA;

var
  errorclassnames: array[DP_OK..DP_ERROR_USR_ABORT] of string =
  (
    'DP_OK: everything is OK',
    'DP_ERROR_EVENT_NET: something wrong with the communication',
    'DP_ERROR_REQ_PAR: wrong call or wrong parameters',
    'DP_ERROR_CI: not used',
    'DP_ERROR_RES: not enough system or layer2 ressources',
    'DP_ERROR_USR_ABORT: not used'
    );
  errornames: array[DP_ERROR_EVENT_NET..DP_ERROR_RES] of array[DP_ERROR_CODEMIN..DP_ERROR_CODEMAX] of string =
  (
    (//DP_ERROR_EVENT_NET
    'DPS_ERROR_EV_NO_DATA_EX: DP-Slave is not in Data-Exchange',
    'DPS_ERROR_EV_START_FAILED: Start-Command failed',
    'DPS_ERROR_SIM9SYNC_FAILED: call to sim9sync failed, contact SIEMENS AG',
    'DPS_ERROR_EV_COMM_ERR: communication error',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    ''
    ),
    (//DP_ERROR_REQ_PAR
    'DPS_ERROR_PAR_INTERNAL: internal Error: contact SIEMENS AG',
    'DPS_ERROR_PAR_SLAVE_MODE: this slave_mode is not allowed',
    'DPS_ERROR_PAR_ADDR_CHANGE: no addr_change allowed',
    'DPS_ERROR_PAR_USER_HANDLE: wrong user_handle',
    'DPS_ERROR_PAR_STATION_ADDR: station_addr > 126 not allowed',
    'DPS_ERROR_PAR_INPUT_DATA: no input data ptr',
    'DPS_ERROR_PAR_OUTPUT_DATA: no output data ptr',
    'DPS_ERROR_PAR_BAUDRATE: wrong baudrate',
    'DPS_ERROR_REQ_NOT_ALLOWED: this request is not allowed in this state',
    'DPS_ERROR_REQ_DPS_ACTIVE: this request is not allowed, there is another active request',
    'DPS_ERROR_PAR_OUTPUT_LEN: parameter len is wrong',
    'DPS_ERROR_PAR_INPUT_LEN: parameter len is wrong',
    'DPS_ERROR_PAR_IO_LEN: too much I/O configured; only 122 I/O allowed',
    'DPS_ERROR_PAR_CFG_DATA: wrong cfg_data: no input and no output'
    ),
    (//unused slot
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    '',
    ''
    ),
    (//DP_ERROR_RES
    'DPS_ERROR_RES_OPEN: no further SCP_OPEN possible',
    'DPS_ERROR_RES_ALLOC: System- or Layer2 - Alloc failed',
    'DPS_ERROR_RES_DEALLOC: System- or Layer2 - DeAlloc failed',
    'DPS_ERROR_RES_REG_BAUDRATE: write baudrate into registry failed',
    'DPS_ERROR_RES_REG_TS: write station address into registry failed',
    'DPS_ERROR_RES_REG_LOG_DEVICE: log. device or name not detected in registry',
    'DPS_ERROR_RES_REG_TSLOT: write tslot into registry failed',
    '',
    '',
    '',
    '',
    '',
    '',
    ''
    )
    );

function cfgdata(len:byte;inp:boolean=false;outp:boolean=false):byte;

implementation

function cfgdata(len:byte;inp:boolean=false;outp:boolean=false):byte;
asm
   mov al,len;
   sub al,1;
   and al,$F;
   mov dl,inp;
   shl dl,4;
   or al,dl;
   mov dl,outp;
   shl dl,5;
   or al,dl;
end;

{$IFNDEF dynamicbinding}
function DPS_open(logname: PDPR_STRING;
  var user_handle: DPR_DWORD;
  slave_mode: DPR_DWORD;
  station_addr: DPR_WORD;
  addr_change: DPR_WORD;
  pno_ident_nr: DPR_WORD;
  user_wd: DPR_WORD;
  var init_data: DPS_INIT_DATA;
  var max_data_len: DPS_MAX_DATA;
  baudrate: DPR_WORD;
  var error: DP_ERROR): DPR_DWORD; external libname; {$IFDEF stdcallconv}stdcall; {$ELSE}cdecl; {$ENDIF}

function DPS_start(user_handle: DPR_DWORD; var error: DP_ERROR): DPR_DWORD; external libname; {$IFDEF stdcallconv}stdcall; {$ELSE}cdecl; {$ENDIF}
function DPS_stop(user_handle: DPR_DWORD; var error: DP_ERROR): DPR_DWORD; external libname; {$IFDEF stdcallconv}stdcall; {$ELSE}cdecl; {$ENDIF}
function DPS_close(user_handle: DPR_DWORD; var error: DP_ERROR): DPR_DWORD; external libname; {$IFDEF stdcallconv}stdcall; {$ELSE}cdecl; {$ENDIF}

function DPS_set_input(user_handle: DPR_DWORD;
  data: PDPR_BYTE;
  len: DPR_WORD;
  var error: DP_ERROR): DPR_DWORD; external libname; {$IFDEF stdcallconv}stdcall; {$ELSE}cdecl; {$ENDIF}

function DPS_get_output(user_handle: DPR_DWORD;
  data: PDPR_BYTE;
  len: DPR_WORD;
  var error: DP_ERROR): DPR_DWORD; external libname; {$IFDEF stdcallconv}stdcall; {$ELSE}cdecl; {$ENDIF}
{$ELSE}
var lib: THandle;

procedure dummy;
begin
     messagebox(0,'Function entry point not available',nil,0);
end;

initialization
  lib := LoadLibrary(libname);
  case lib = 0 of
    true:
      begin
        messagebox(0, pchar('DLL: "' + libname + '" not loaded!'), nil, 0);
        @DPS_start := @dummy;
        @DPS_stop :=  @dummy;
        @DPS_open :=  @dummy;
        @DPS_close :=  @dummy;
        @DPS_set_input :=  @dummy;
        @DPS_get_output :=  @dummy;
      end;
    false:
      begin
        @DPS_start := GetProcAddress(lib, 'DPS_start');
        @DPS_stop := GetProcAddress(lib, 'DPS_stop');
        @DPS_open := GetProcAddress(lib, 'DPS_open');
        @DPS_close := GetProcAddress(lib, 'DPS_close');
        @DPS_set_input := GetProcAddress(lib, 'DPS_set_input');
        @DPS_get_output := GetProcAddress(lib, 'DPS_get_output');

        if ((@DPS_start = nil) or
        (@DPS_stop = nil) or
        (@DPS_open = nil) or
        (@DPS_close = nil) or
        (@DPS_set_input = nil) or
        (@DPS_get_output = nil)) then begin
          FreeLibrary(lib);
          messagebox(0, pchar('Entrypoint of at least one function in DLL: "' + libname + '" not found!'), nil, 0);
        end;
      end;
  end;

finalization
  if lib <> 0 then FreeLibrary(lib);
{$ENDIF}
end.

